BEGIN {
    FS = ","
    printf "[\n";
    parent = 0;
    child = 0
}

END {
    printf "]\n";
}

func save_parent(name, mib, src, subsys, units, ob, hname, d) {
    pname = name;
    mib_id = mib;
    source = src;
    subsystem = subsys;
    unit = units;
    obs = ob;
    hkname = hname;
    desc = d;
    parent = 1;
}

# {"name" : "VIS_ROE_FPGA_TEMP_T_01", "MIB_id" : "VS1T2081"},
func save_child(name, mib, src, subsys, units) {
    str = sprintf("{\"name\":\"%s\", \"MIB_id\" : \"%s\"}", name, mib);
    children[child] = str;
    ++child;
}

func print_children() {
    for(i = 0; i < child; ++i) {
	if (i == (child - 1)) {
	    printf("\t\t\t%s\n", children[i]);
	}
	else {
	    printf("\t\t\t%s,\n", children[i]);
	}
    }
}

func print_parent() {
    if(parent) {
	printf("\t{\"parent\" : {\n");
	printf("\t\t\"name\" : \"%s\",\n", pname);
	printf("\t\t\"MIB_id\" : \"%s\",\n", mib_id);
	printf("\t\t\"source\" : \"%s\",\n", source);
	printf("\t\t\"subsystem\" : \"%s\",\n", subsystem);
	printf("\t\t\"units\" : \"%s\",\n", unit);
	print_json("OBS_param_id", obs);
	print_json("HK_name", hkname);
	print_json("description", desc);
	printf("\t\t\"children\" : [\n");
	print_children();
	printf("\t\t]},\n");
#	printf("\t},\n");
    }
    child = 0;
    parent = 0;
}

func print_json_title(title) {
    printf("\t{\"%s\" : {\n", title);    
}

func print_json(name, value) {
    printf("\t\t\"%s\" : \"%s\",\n", name, value);    
}

func print_orphan(name, mib, src, subsys, units, obs, hkname, desc) {
    parent = 0;
    printf("\t{\"orphan\" : {\n");
    print_json("name", name);
    print_json("MIB_id", mib);
    print_json("source", src);
    print_json("subsystem", subsys);
    print_json("units", units);
    print_json("OBS_param_id", obs);
    print_json("HK_name", hkname);
    print_json("description", desc);
    printf("\t}}\n");
}

/^#/      { next }
/^\?/     { next }
/^---/    { save_parent($2, $3, $4, $6, $5, $7, $8, $9) ; next }
/^\+\+\+/ { save_parent($2, $3, $4, $6, $5, $7, $8, $9) ; next }
/^$/      { print_parent() ; next }
          { if (parent) { save_child($1, $2) ; } else { print_orphan($1, $2, $3, $5, $4, $6, $7, $8) }}

#{ print $1 $2 $3 }

#    {"orphan" : {
#	"name" : "VIS_CDPU_5V_VPU",
#	"MIB_id" : "VDGT2712",
#	"source" : "rt_slow",
#	"subsystem" : "CDPU",
#	"units" : "V",
#	"range" : {"min" : 0, "max" : 10},
#	"OBS_param_id" : "0x0201",
#	"HK_name" : "CDPU_5V_CPU",
#	"description" : "1553 Interface Power Supply"
#    }}

#    { "parent": {
#	"name" : "VIS_ROE_FPGA_TEMP_T",
#	"MIB_id" : "VSGT2081",
#	"source" : "rt_slow",
#	"subsystem" : "ROE",
#	"units" : "V",
#	"range" : {"min" : 0, "max" : 10},
#	"OBS_param_id" : "0x0156",
#	"HK_name" : "fpga_pcb_temp_t",
#	"description" : "FPGA pcb temp voltage - Top",
#	"children" : [
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_01", "MIB_id" : "VS1T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_02", "MIB_id" : "VS2T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_03", "MIB_id" : "VS3T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_04", "MIB_id" : "VS4T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_05", "MIB_id" : "VS5T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_06", "MIB_id" : "VS6T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_07", "MIB_id" : "VS7T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_08", "MIB_id" : "VS8T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_09", "MIB_id" : "VS9T2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_10", "MIB_id" : "VSAT2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_11", "MIB_id" : "VSBT2081"},
#	    {"name" : "VIS_ROE_FPGA_TEMP_T_12", "MIB_id" : "VSCT2081"}
#	]}
#    },
